
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include "dlldebug.h"
#include "apihook.h"



///////////////////////////////////////////////////////////////
// 萔
#define INIFILENAME				"FontChanger.ini"		// ݒt@C
#define INIFILESECTION			"Font"					// ݒt@C̃ZNV


///////////////////////////////////////////////////////////////
// W[ϐ
static APIHOOKINFO			mCreateFontA_HookInfo;		// tbN
static CRITICAL_SECTION		mCreateFontA_CS;			// NeBJZNV
static bool					mInitializedCS = false;		// NeBJZNV̏L

static char					mFontName[MAX_PATH];		// tHg
static DWORD				mFontCharSet;				// tHgLZbg
static int					mFontSizeA;					// tHgTCYWA
static int					mFontSizeB;					// tHgTCYWB


///////////////////////////////////////////////////////////////
// vg^Cv錾
HFONT WINAPI Custom_CreateFontA( int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCTSTR lpszFace );


///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////
// DLLC
BOOL APIENTRY DllMain( HANDLE hModule, DWORD  Reason, LPVOID lpReserved )
{
	switch( Reason )
	{
		case DLL_PROCESS_ATTACH:	// DLLvZXɓǂݍ܂ꂽ
			{
				DEBUGPRINT(( "1 FontChanger PID=%08x\n", GetCurrentProcessId() ));

				// ݒt@Č
				char inifile[MAX_PATH];
				memset( inifile, 0, MAX_PATH );
				GetModuleFileName( NULL, inifile, MAX_PATH );
				DEBUGPRINT(( "Program : '%s'\n", inifile ));
				int x;
				for( x = MAX_PATH - 1; x > 0; x-- )
				{
					if( inifile[x] == '\\' )	break;
					inifile[x] = 0;
				}
				strncat_s( inifile, MAX_PATH, INIFILENAME, _TRUNCATE );
				DEBUGPRINT(( "Inifile : '%s'\n", inifile ));

				// ݒ̓Ǎ
				memset( mFontName, 0, MAX_PATH );
				GetPrivateProfileString( INIFILESECTION, "Name", "", mFontName, MAX_PATH, inifile );
				mFontCharSet	= GetPrivateProfileInt( INIFILESECTION, "CharSet", 128, inifile );
				mFontSizeA		= GetPrivateProfileInt( INIFILESECTION, "SizeA", 100, inifile );
				mFontSizeB		= GetPrivateProfileInt( INIFILESECTION, "SizeB", 0, inifile );
				DEBUGPRINT(( "FontName = '%s'\n", mFontName ));
				DEBUGPRINT(( "CharSet = %d\n", mFontCharSet ));
				DEBUGPRINT(( "Size = %d %d\n", mFontSizeA, mFontSizeB ));

				// tbN
				mCreateFontA_HookInfo.CustomAdrs	= (DWORD)Custom_CreateFontA;
				if( SetupAPIHook( "GDI32.dll", "CreateFontA", mCreateFontA_HookInfo ) == 0 )
				{
					// tbNJn
					EnableHook( mCreateFontA_HookInfo );
				}
			}
			break;

		case DLL_THREAD_ATTACH:
			break;

		case DLL_THREAD_DETACH:
			break;

		case DLL_PROCESS_DETACH:
			break;
	}

	return TRUE;
}


///////////////////////////////////////////////////////////////
// bp֐

// CreateFontAp
HFONT WINAPI Custom_CreateFontA( int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCTSTR lpszFace )
{
	// NeBJZNVJn
	if( mInitializedCS == false ) 
	{
		// }`XbhΉpNeBJZNV
		InitializeCriticalSection( &mCreateFontA_CS );
	}
	EnterCriticalSection( &mCreateFontA_CS );

	// tbN߂
	DisableHook( mCreateFontA_HookInfo );

	// ̕ύX
	DEBUGPRINT(( "Call CreateFontA Before: Name='%s' CharSet=%d Width=%d Height=%d\n", lpszFace, fdwCharSet, nWidth, nHeight ));
	if( mFontName[0] != 0 )
	{
		// tHgύX
		lpszFace = mFontName;
	}
	if( mFontCharSet <= 0x7fffffff )
	{
		// LZbgύX
		fdwCharSet = mFontCharSet;		
	}
	nHeight = nHeight * mFontSizeA / 100 + mFontSizeB;		// tHgTCY
	nWidth = nWidth * mFontSizeA / 100 + mFontSizeB;

	// {APIĂяo
	HFONT ret = CreateFontA( nHeight, nWidth, nEscapement, nOrientation, fnWeight, fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily, lpszFace );
	DEBUGPRINT(( "Call CreateFontA After : Name='%s' CharSet=%d Width=%d Height=%d, ret=%08X\n", lpszFace, fdwCharSet, nWidth, nHeight, (unsigned int)ret ));

	// tbNLɂ
	EnableHook( mCreateFontA_HookInfo );

	// NeBJZNVI
	LeaveCriticalSection( &mCreateFontA_CS );

	return ret;
}

